org.apache.lucene.analysis.ngram

## Class EdgeNGramTokenizer

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.Tokenizer
      - - org.apache.lucene.analysis.ngram.EdgeNGramTokenizer

-     public class EdgeNGramTokenizer
      extends org.apache.lucene.analysis.Tokenizer

  Tokenizes the input from an edge into n-grams of given size(s).

  This `Tokenizer` create n-grams from the beginning edge or ending edge of a input token. MaxGram can't be larger than 1024 because of limitation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `EdgeNGramTokenizer.Side` Specifies which side of the input the n-gram should be generated from

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `org.apache.lucene.util.AttributeSource.AttributeFactory, org.apache.lucene.util.AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_MAX_GRAM_SIZE`
    `static int` | `DEFAULT_MIN_GRAM_SIZE`
    `static EdgeNGramTokenizer.Side` | `DEFAULT_SIDE`

    - ### Fields inherited from class org.apache.lucene.analysis.Tokenizer

      `input`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource.AttributeFactory factory, java.io.Reader input, EdgeNGramTokenizer.Side side, int minGram, int maxGram)` Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
    `EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource.AttributeFactory factory, java.io.Reader input, java.lang.String sideLabel, int minGram, int maxGram)` Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
    `EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource source, java.io.Reader input, EdgeNGramTokenizer.Side side, int minGram, int maxGram)` Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
    `EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource source, java.io.Reader input, java.lang.String sideLabel, int minGram, int maxGram)` Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
    `EdgeNGramTokenizer(java.io.Reader input, EdgeNGramTokenizer.Side side, int minGram, int maxGram)` Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
    `EdgeNGramTokenizer(java.io.Reader input, java.lang.String sideLabel, int minGram, int maxGram)` Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `end()`
    `boolean` | `incrementToken()` Returns the next token in the stream, or null at EOS.
    `org.apache.lucene.analysis.Token` | `next()` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `org.apache.lucene.analysis.Token` | `next(org.apache.lucene.analysis.Token reusableToken)` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `void` | `reset()`
    `void` | `reset(java.io.Reader input)`

    - ### Methods inherited from class org.apache.lucene.analysis.Tokenizer

      `close, correctOffset`

    - ### Methods inherited from class org.apache.lucene.analysis.TokenStream

      `getOnlyUseNewAPI, setOnlyUseNewAPI`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_SIDE

          public static final EdgeNGramTokenizer.Side DEFAULT_SIDE

    - #### DEFAULT_MAX_GRAM_SIZE

          public static final int DEFAULT_MAX_GRAM_SIZE

      See Also:
        Constant Field Values

    - #### DEFAULT_MIN_GRAM_SIZE

          public static final int DEFAULT_MIN_GRAM_SIZE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EdgeNGramTokenizer

          public EdgeNGramTokenizer(java.io.Reader input,
                                    EdgeNGramTokenizer.Side side,
                                    int minGram,
                                    int maxGram)

      Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
      Parameters:
        `input` - `Reader` holding the input to be tokenized
        `side` - the `EdgeNGramTokenizer.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

    - #### EdgeNGramTokenizer

          public EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource source,
                                    java.io.Reader input,
                                    EdgeNGramTokenizer.Side side,
                                    int minGram,
                                    int maxGram)

      Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
      Parameters:
        `source` - `AttributeSource` to use
        `input` - `Reader` holding the input to be tokenized
        `side` - the `EdgeNGramTokenizer.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

    - #### EdgeNGramTokenizer

          public EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource.AttributeFactory factory,
                                    java.io.Reader input,
                                    EdgeNGramTokenizer.Side side,
                                    int minGram,
                                    int maxGram)

      Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
      Parameters:
        `factory` - `AttributeSource.AttributeFactory` to use
        `input` - `Reader` holding the input to be tokenized
        `side` - the `EdgeNGramTokenizer.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

    - #### EdgeNGramTokenizer

          public EdgeNGramTokenizer(java.io.Reader input,
                                    java.lang.String sideLabel,
                                    int minGram,
                                    int maxGram)

      Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
      Parameters:
        `input` - `Reader` holding the input to be tokenized
        `sideLabel` - the name of the `EdgeNGramTokenizer.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

    - #### EdgeNGramTokenizer

          public EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource source,
                                    java.io.Reader input,
                                    java.lang.String sideLabel,
                                    int minGram,
                                    int maxGram)

      Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
      Parameters:
        `source` - `AttributeSource` to use
        `input` - `Reader` holding the input to be tokenized
        `sideLabel` - the name of the `EdgeNGramTokenizer.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

    - #### EdgeNGramTokenizer

          public EdgeNGramTokenizer(org.apache.lucene.util.AttributeSource.AttributeFactory factory,
                                    java.io.Reader input,
                                    java.lang.String sideLabel,
                                    int minGram,
                                    int maxGram)

      Creates EdgeNGramTokenizer that can generate n-grams in the sizes of the given range
      Parameters:
        `factory` - `AttributeSource.AttributeFactory` to use
        `input` - `Reader` holding the input to be tokenized
        `sideLabel` - the name of the `EdgeNGramTokenizer.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

  - ### Method Detail

    - #### incrementToken

          public final boolean incrementToken()
                                       throws java.io.IOException

      Returns the next token in the stream, or null at EOS.
      Overrides:
        `incrementToken` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### end

          public final void end()

      Overrides:
        `end` in class `org.apache.lucene.analysis.TokenStream`

    - #### next

          public final org.apache.lucene.analysis.Token next(org.apache.lucene.analysis.Token reusableToken)
                                                      throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Overrides:
        `next` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### next

          public final org.apache.lucene.analysis.Token next()
                                                      throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Overrides:
        `next` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### reset

          public void reset(java.io.Reader input)
                     throws java.io.IOException

      Overrides:
        `reset` in class `org.apache.lucene.analysis.Tokenizer`
      Throws:
        `java.io.IOException`

    - #### reset

          public void reset()
                     throws java.io.IOException

      Overrides:
        `reset` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.